diff --git a/drivers/net/ice/base/ice_flex_type.h b/drivers/net/ice/base/ice_flex_type.h
index d45653b637..2855d67831 100644
--- a/drivers/net/ice/base/ice_flex_type.h
+++ b/drivers/net/ice/base/ice_flex_type.h
@@ -174,36 +174,36 @@ struct ice_fv {
 #define ICE_MAC_IPV6_PFCP_SESSION		354
 #define ICE_MAC_IPV4_L2TPV3			360
 #define ICE_MAC_IPV6_L2TPV3			361
-#define ICE_MAC_IPV4_L2TPV2_CONTROL		392
-#define ICE_MAC_IPV6_L2TPV2_CONTROL		393
-#define ICE_MAC_IPV4_L2TPV2			394
-#define ICE_MAC_IPV6_L2TPV2			395
-#define ICE_MAC_IPV4_PPPOL2TPV2			396
-#define ICE_MAC_IPV6_PPPOL2TPV2			397
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_FRAG	398
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_PAY	399
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_UDP_PAY	400
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_TCP	401
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_SCTP	402
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_ICMP	403
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_FRAG	404
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_PAY	405
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_UDP_PAY	406
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_TCP	407
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_SCTP	408
-#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_ICMPV6	409
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_FRAG	410
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_PAY	411
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_UDP_PAY	412
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_TCP	413
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_SCTP	414
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_ICMP	415
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_FRAG	416
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_PAY	417
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_UDP_PAY	418
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_TCP	419
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_SCTP	420
-#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_ICMPV6	421
+#define ICE_MAC_IPV4_L2TPV2_CONTROL		396
+#define ICE_MAC_IPV6_L2TPV2_CONTROL		397
+#define ICE_MAC_IPV4_L2TPV2			398
+#define ICE_MAC_IPV6_L2TPV2			399
+#define ICE_MAC_IPV4_PPPOL2TPV2			400
+#define ICE_MAC_IPV6_PPPOL2TPV2			401
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_FRAG	402
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_PAY	403
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_UDP_PAY	404
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_TCP	405
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_SCTP	406
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV4_ICMP	407
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_FRAG	408
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_PAY	409
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_UDP_PAY	410
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_TCP	411
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_SCTP	412
+#define ICE_MAC_IPV4_PPPOL2TPV2_IPV6_ICMPV6	413
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_FRAG	414
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_PAY	415
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_UDP_PAY	416
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_TCP	417
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_SCTP	418
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV4_ICMP	419
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_FRAG	420
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_PAY	421
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_UDP_PAY	422
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_TCP	423
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_SCTP	424
+#define ICE_MAC_IPV6_PPPOL2TPV2_IPV6_ICMPV6	425
 #define MAC_IPV4_TUN_IPV4_GTPU_IPV4_FRAG	450
 #define MAC_IPV4_TUN_IPV4_GTPU_IPV4_PAY		451
 #define MAC_IPV4_TUN_IPV4_GTPU_IPV4_UDP_PAY	452
diff --git a/drivers/net/ice/base/ice_flow.c b/drivers/net/ice/base/ice_flow.c
index 80e7a447c3..bdc51ca9d2 100644
--- a/drivers/net/ice/base/ice_flow.c
+++ b/drivers/net/ice/base/ice_flow.c
@@ -239,7 +239,7 @@ static const u32 ice_ptypes_mac_ofos[] = {
 	0xFDC00846, 0xBFBF7F7E, 0xF70001DF, 0xFEFDFDFB,
 	0x0000077E, 0x000003FF, 0x00000000, 0x00000000,
 	0x00400000, 0x03FFF000, 0xFFFFFFE0, 0x00100707,
-	0xFFFFFF00, 0x0000003F, 0x00000000, 0x00000000,
+	0xFFFFF000, 0x000003FF, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -265,7 +265,7 @@ static const u32 ice_ptypes_ipv4_ofos[] = {
 	0x1D800000, 0xBFBF7800, 0x000001DF, 0x00000000,
 	0x00000000, 0x00000155, 0x00000000, 0x00000000,
 	0x00000000, 0x000FC000, 0x000002A0, 0x00100000,
-	0x00001500, 0x00000000, 0x00000000, 0x00000000,
+	0x00015000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -279,7 +279,7 @@ static const u32 ice_ptypes_ipv4_ofos_all[] = {
 	0x1D800000, 0x27BF7800, 0x00000000, 0x00000000,
 	0x00000000, 0x00000155, 0x00000000, 0x00000000,
 	0x00000000, 0x000FC000, 0x83E0FAA0, 0x00000101,
-	0x03FFD000, 0x00000000, 0x02FBEFBC, 0x00000000,
+	0x3FFD5000, 0x00000000, 0x02FBEFBC, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -291,7 +291,7 @@ static const u32 ice_ptypes_ipv4_il[] = {
 	0xE0000000, 0xB807700E, 0x80000003, 0xE01DC03B,
 	0x0000000E, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x001FF800, 0x00100000,
-	0xFC0FC000, 0x00000000, 0xBC0BC0BC, 0x00000BC0,
+	0xC0FC0000, 0x0000000F, 0xBC0BC0BC, 0x00000BC0,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -305,7 +305,7 @@ static const u32 ice_ptypes_ipv6_ofos[] = {
 	0x00000000, 0x00000000, 0x76000000, 0x10002000,
 	0x00000000, 0x000002AA, 0x00000000, 0x00000000,
 	0x00000000, 0x03F00000, 0x00000540, 0x00000000,
-	0x00002A00, 0x00000000, 0x00000000, 0x00000000,
+	0x0002A000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -319,7 +319,7 @@ static const u32 ice_ptypes_ipv6_ofos_all[] = {
 	0x00000000, 0x00000000, 0x76000000, 0xFEFDE000,
 	0x0000077E, 0x000002AA, 0x00000000, 0x00000000,
 	0x00000000, 0x03F00000, 0x7C1F0540, 0x00000206,
-	0xFC002000, 0x0000003F, 0xBC000000, 0x0002FBEF,
+	0xC002A000, 0x000003FF, 0xBC000000, 0x0002FBEF,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -331,7 +331,7 @@ static const u32 ice_ptypes_ipv6_il[] = {
 	0x00000000, 0x03B80770, 0x000001DC, 0x0EE00000,
 	0x00000770, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x7FE00000, 0x00000000,
-	0x03F00000, 0x0000003F, 0x02F02F00, 0x0002F02F,
+	0x3F000000, 0x000003F0, 0x02F02F00, 0x0002F02F,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -345,7 +345,7 @@ static const u32 ice_ptypes_ipv4_ofos_no_l4[] = {
 	0x10800000, 0x04000800, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x000cc000, 0x000002A0, 0x00000000,
-	0x00001500, 0x00000000, 0x00000000, 0x00000000,
+	0x00015000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -357,7 +357,7 @@ static const u32 ice_ptypes_ipv4_il_no_l4[] = {
 	0x60000000, 0x18043008, 0x80000002, 0x6010c021,
 	0x00000008, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00139800, 0x00000000,
-	0x8C08C000, 0x00000000, 0x00000000, 0x00000000,
+	0xC08C0000, 0x00000008, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -371,7 +371,7 @@ static const u32 ice_ptypes_ipv6_ofos_no_l4[] = {
 	0x00000000, 0x00000000, 0x42000000, 0x10002000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x02300000, 0x00000540, 0x00000000,
-	0x00002A00, 0x00000000, 0x00000000, 0x00000000,
+	0x0002A000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -383,7 +383,7 @@ static const u32 ice_ptypes_ipv6_il_no_l4[] = {
 	0x00000000, 0x02180430, 0x0000010c, 0x086010c0,
 	0x00000430, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x4e600000, 0x00000000,
-	0x02300000, 0x00000023, 0x00000000, 0x00000000,
+	0x23000000, 0x00000230, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -409,7 +409,7 @@ static const u32 ice_ptypes_udp_il[] = {
 	0x81000000, 0x20204040, 0x04000010, 0x80810102,
 	0x00000040, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00410000, 0x908427E0, 0x00100007,
-	0x10410000, 0x00000004, 0x10410410, 0x00004104,
+	0x0413F000, 0x00000041, 0x10410410, 0x00004104,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -421,7 +421,7 @@ static const u32 ice_ptypes_tcp_il[] = {
 	0x04000000, 0x80810102, 0x10000040, 0x02040408,
 	0x00000102, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00820000, 0x21084000, 0x00000000,
-	0x20820000, 0x00000008, 0x20820820, 0x00008208,
+	0x08200000, 0x00000082, 0x20820820, 0x00008208,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -433,7 +433,7 @@ static const u32 ice_ptypes_sctp_il[] = {
 	0x08000000, 0x01020204, 0x20000081, 0x04080810,
 	0x00000204, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x01040000, 0x00000000, 0x00000000,
-	0x41040000, 0x00000010, 0x00000000, 0x00000000,
+	0x10400000, 0x00000104, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -457,7 +457,7 @@ static const u32 ice_ptypes_icmp_il[] = {
 	0x00000000, 0x02040408, 0x40000102, 0x08101020,
 	0x00000408, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x42108000, 0x00000000,
-	0x82080000, 0x00000020, 0x00000000, 0x00000000,
+	0x20800000, 0x00000208, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -920,7 +920,7 @@ static const u32 ice_ptypes_l2tpv2[] = {
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
-	0xFFFFFF00, 0x0000003F, 0x00000000, 0x00000000,
+	0xFFFFF000, 0x000003FF, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
@@ -931,7 +931,7 @@ static const u32 ice_ptypes_ppp[] = {
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
-	0xFFFFF000, 0x0000003F, 0x00000000, 0x00000000,
+	0xFFFF0000, 0x000003FF, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,
 	0x00000000, 0x00000000, 0x00000000, 0x00000000,